﻿define("bynder/BynderInitializer", [
    "dojo/_base/declare",
    "epi/_Module",
    "epi/shell/command/_Command", 
    "epi/routes",
    "epi/shell/conversion/ObjectConverterRegistry",
    "epi-cms/plugin-area/content-selector-plugandplay",
    "bynder/commands/BynderAddAssetCommand",
    "bynder/BynderAssetDataConverter",
    "xstyle/css!./Bynder.css"

], function(
    declare,
    _Module,
    _Command,
    routes,
    ObjectConverterRegistry, 
    pluginArea,
    BynderAddAssetCommand,
    BynderAssetDataConverter,
) {
    return declare([_Module], {
        _settings: null,

        constructor: function (settings) {
            this._settings = settings;
        },

        initialize: function() {
            this.inherited(arguments);

            var registry = this.resolveDependency("epi.storeregistry");
            // Register the stores
            var options = {
                idProperty: "contentLink",
            };
            registry.create("BynderAssetStore", this._getRestPath("BynderAssetStore"), options);
            registry.create(
                "BynderAssetMappingStore",
                this._getRestPath("BynderAssetMappingStore"),
                options
            );

            // Register data converter for TinyMCE drop
            var converter = new BynderAssetDataConverter();
            ObjectConverterRegistry.registerConverter(
                converter.sourceDataType,
                converter.targetDataType,
                converter
            );

            if (this._settings && !this._settings.disableBynderAddAssetCommand) {
                pluginArea.add(new BynderAddAssetCommand({
                    settings: this._settings
                }));
            }
        },

        _getRestPath: function(name) {
            return routes.getRestPath({
                moduleArea: "bynder",
                storeName: name,
            });
        },
    });
});
